Index: Makefile
===================================================================
--- Makefile	(revision b41a35800b6b1e11eacd6c6b2bea819aafe3d8ff)
+++ Makefile	(revision a4d8e191b95d95650d413c1c2723fb70ec9c7f32)
@@ -21,4 +21,5 @@
 C_FILES += rtemsbsd/dev/usb/controller/ohci_lpc32xx.c
 C_FILES += rtemsbsd/dev/usb/controller/ehci_mpc83xx.c
+C_FILES += rtemsbsd/src/rtems-bsd-thread0-ucred.c
 C_FILES += rtemsbsd/src/rtems-bsd-cam.c
 C_FILES += rtemsbsd/src/rtems-bsd-nexus.c
Index: freebsd-to-rtems.py
===================================================================
--- freebsd-to-rtems.py	(revision b41a35800b6b1e11eacd6c6b2bea819aafe3d8ff)
+++ freebsd-to-rtems.py	(revision a4d8e191b95d95650d413c1c2723fb70ec9c7f32)
@@ -514,4 +514,5 @@
 		'dev/usb/controller/ohci_lpc32xx.c',
 		'dev/usb/controller/ehci_mpc83xx.c',
+		'src/rtems-bsd-thread0-ucred.c',
 		'src/rtems-bsd-cam.c',
 		'src/rtems-bsd-nexus.c',
Index: freebsd/kern/init_main.c
===================================================================
--- freebsd/kern/init_main.c	(revision b41a35800b6b1e11eacd6c6b2bea819aafe3d8ff)
+++ freebsd/kern/init_main.c	(revision a4d8e191b95d95650d413c1c2723fb70ec9c7f32)
@@ -119,6 +119,4 @@
  * If we want to register new sysinit types, add them to newsysinit.
  */
-#else  /* __rtems__ */
-struct ucred *rtems_bsd_thread0_ucred;
 #endif /* __rtems__ */
 SET_DECLARE(sysinit_set, struct sysinit);
@@ -194,11 +192,4 @@
 	if (boothowto & RB_VERBOSE)
 		bootverbose++;
-#else  /* __rtems__ */
-	rtems_bsd_thread0_ucred = crget();
-	rtems_bsd_thread0_ucred->cr_ngroups = 1;	/* group 0 */
-	rtems_bsd_thread0_ucred->cr_uidinfo = uifind(0);
-	rtems_bsd_thread0_ucred = uifind(0);
-	rtems_bsd_thread0_ucred->cr_prison = &prison0;
-
 #endif /* __rtems__ */
 
Index: rtemsbsd/src/rtems-bsd-thread0-ucred.c
===================================================================
--- rtemsbsd/src/rtems-bsd-thread0-ucred.c	(revision a4d8e191b95d95650d413c1c2723fb70ec9c7f32)
+++ rtemsbsd/src/rtems-bsd-thread0-ucred.c	(revision a4d8e191b95d95650d413c1c2723fb70ec9c7f32)
@@ -0,0 +1,53 @@
+/**
+ * @file
+ *
+ * @ingroup rtems_bsd_rtems
+ */
+
+/*
+ * Copyright (c) 2012  On-Line Applications Research Corporation (OAR).
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <freebsd/machine/rtems-bsd-config.h>
+
+#include <freebsd/sys/param.h>
+#include <freebsd/sys/types.h>
+#include <freebsd/sys/systm.h>
+#include <freebsd/sys/proc.h>
+#include <freebsd/sys/jail.h>
+#include <freebsd/sys/kernel.h>
+
+struct ucred *rtems_bsd_thread0_ucred;
+
+static void rtems_bsd_thread0_ucred_init(void *arg)
+{
+	rtems_bsd_thread0_ucred = crget();
+	rtems_bsd_thread0_ucred->cr_ngroups = 1;	/* group 0 */
+	rtems_bsd_thread0_ucred->cr_uidinfo = uifind(0);
+	rtems_bsd_thread0_ucred = uifind(0);
+	rtems_bsd_thread0_ucred->cr_prison = &prison0;
+}
+
+SYSINIT(cpu, SI_SUB_CPU, SI_ORDER_FIRST, rtems_bsd_thread0_ucred_init, NULL);
